{$ifdef debug}
procedure freemem(var p;size:integer);
begin
 writeln('Mem:free(',size,')');
 system.freemem(pointer(p),size);
end;

procedure _freemem(var p);
begin
 writeln('Mem:free(?)');
 system.freemem(pointer(p));
end;
procedure getmem(var p;size:integer);
begin
 writeln('Mem:get(',size,')');
 system.getmem(pointer(p),size); 
end;
procedure getzero(var p;size:integer);
begin
 writeln('Mem:get(',size,')');
 bilbo.getzero(pointer(p),size);
end;
{$endif}

type
 action=(ac_send,ac_exec,ac_execnph,ac_forbid,ac_sendnph);
 buffer=array[1..client_buffer] of byte;
 pbuffer=^buffer;
 send_struct=record
  b:pbuffer;{buffer na vstup}
  by:u_val;{kolik je v nem znaku}
  out:pbuffer;{buffer na vystup}
  oc:u_val;{kolik je v nem znaku}
  s:longint;{socket kam se data posilaji}
  filename:ansistring;{jmeno souboru, nezacina na '/', takze lze k nemu pridat webroot}
  qs:ansistring;{querystring}
  method:shortstring;{request method}
  req:ansistring;{request}
  req_extra:integer;{pocet prijatych bytu za crlf/crlf}
  url:ansistring;{request url}
  line1:ansistring;{prvni radka requestu}
  host:ansistring;{hostname v requestu}
  h:thandle;{pripadna otevrena handle}
  proto:ansistring;{protocol(HTTP/X.X)}
  config,adef:pointer;{pointer na config, musi se natypecastit}
  remote:integer;{remote_ip}
  contentlen:integer;{content-length(nastavuje se az v send_simpleheader)}
  verified:boolean;{pokud je vyzadovana autentifikace a uzivatel se uspesne prihlasil tak true, jinak false}
  verified_user:ansistring;{pokud verified=true tak tohle obsahuje username}
  errorpage:boolean;{pokud se posila errorpage, tak true, jinak false}
  errorcode:integer;{0=bez chyby, jinak kod chyby}
  privileged:boolean;{true pokud jde o pristup na monitor (spec. privilegia)}
  proxy:boolean;{true pokud je to pristup na proxy (zakaz custom error pages)}
 end;
var
 crit:trtlcriticalsection;
 {server stats}
 sockerrors,threads,in_connections,in_bytes,out_bytes,in_gbytes,out_gbytes:integer;

const
 HKLM=HKEY_LOCAL_MACHINE;

function getremoteip(s:socket):string;
var
 t:sockaddr_in;
 i:integer;
begin
 i:=sizeof(t);
 getpeername(s,psockaddr(@t),@i);
 result:=str_ip(ntohl(longint(t.sin_addr)));
end;

function getremoteport(s:socket):word;
var
 t:sockaddr_in;
 i:integer;
begin
 i:=sizeof(t);
 getpeername(s,psockaddr(@t),@i);
 result:=ntohs(t.sin_port);
end;

function getremote(s:socket):integer;
var
 t:sockaddr_in;
 i:integer;
begin
 i:=sizeof(t);
 getpeername(s,psockaddr(@t),@i);
 result:=ntohl(longint(t.sin_addr));
end;

function reg_get(a:hkey;s:pchar;k:pchar):string;{root, key, field}
var
 l:longint;
 buf:hkey;
 p:array[0..512] of char;
 res:ansistring;
begin
 if regopenkey(a,s,buf)=ERROR_SUCCESS then begin
  l:=512;
  if regqueryvalueEx(buf,k,nil,nil,@(p[0]),@l)=ERROR_SUCCESS then begin
   setlength(res,l);
   move(p[0],res[1],l);
   result:=res;
  end else result:='';
  regclosekey(buf);
 end else begin
  result:='';
 end;
end;

procedure reg_set(a:hkey;s:pchar;k:pchar;typ:integer;q:string);{root,key,field,typ,value}
var
 buf:hkey;
begin
 if regopenkey(a,s,buf)=ERROR_SUCCESS then begin
  regsetvalueEx(buf,k,0,typ,@(q[1]),length(q));
  regclosekey(buf);
 end;
end;

procedure reg_del(a:hkey;s:pchar;k:pchar);{root,key,field}
var
 buf:hkey;
begin
 if regopenkey(a,s,buf)=ERROR_SUCCESS then begin
  regdeletevalue(buf,k);
  regclosekey(buf);
 end;
end;

procedure reg_delkey(a:hkey;s:pchar;k:pchar);{root,key,subkey}
var
 buf:hkey;
begin
 if regopenkey(a,s,buf)=ERROR_SUCCESS then begin
  regdeletekey(buf,k);
  regclosekey(buf);
 end;
end;

function htmlchar(s:ansistring):ansistring;
var
 i:integer;
begin
 if length(s)=0 then begin
  htmlchar:='';
  exit;
 end;
 i:=1;
 while i<=length(s) do begin
  case s[i] of
   '>':begin s[i]:='&';insert('gt;',s,i+1);inc(i,4);end;
   '<':begin s[i]:='&';insert('lt;',s,i+1);inc(i,4);end;
   '&':begin insert('amp;',s,i+1);inc(i,5);end;
  else inc(i);
  end;
 end;
 htmlchar:=s;
end;

procedure thread_exit(var ss:send_struct);
begin
 if ss.b<>nil then freemem(ss.b,client_buffer);
 if ss.out<>nil then freemem(ss.out,client_buffer);
 if ss.s<>INVALID_SOCKET then closesocket(ss.s);
 if ss.h<>INVALID_HANDLE_VALUE then closehandle(ss.h);
 dec(threads);
end;

procedure in_stat(i:integer); {statistika - pricte i bajtu k prichozimu traffic}
begin
 inc(in_bytes,i);
 entercriticalsection(crit);
 if (in_bytes>=hi_point) then begin
  dec(in_bytes,hi_point);
  inc(in_gbytes,1);
 end;
 leavecriticalsection(crit);
end;

procedure out_stat(i:integer); {statistika - pricte i bajtu k odchozimu traffic}
begin
 inc(out_bytes,i);
 entercriticalsection(crit);
 if (out_bytes>=hi_point) then begin
  dec(out_bytes,hi_point);
  inc(out_gbytes,1);
 end;
 leavecriticalsection(crit);
end;

procedure flush_buffer(var ss:send_struct);
var
 i:u_val;
begin
 if ss.oc=0 then exit;
 i:=send(ss.s,@(ss.out^),ss.oc,0);
 if i=u_val(SOCKET_ERROR) then begin
  inc(sockerrors);
  thread_exit(ss);
  exitthread(0);
 end;
 out_stat(i);
 if i=ss.oc then begin
  ss.oc:=0;
  exit;
 end;
 move(ss.out^[i+1],ss.out^[1],ss.oc-i);
 ss.oc:=ss.oc-i;
end;

function getheader2(const s:ansistring;const what:string):ansistring;
var i,j,l:integer;
begin
 l:=length(s);
 i:=pos_i(#10+what+':',s);
 if i=0 then begin
  if beginwithi(s,what+':') then i:=1;
 end;
 if i=0 then begin getheader2:=''; exit;end;
 i:=i+2+length(what);
 while (s[i]=' ') and (i<=l) do inc(i);
 j:=i;
 while not(s[j] in [#13,#10]) and (j<=l) do inc(j);
 getheader2:=copy(s,i,j-i);
end;

function getheader(var ss:send_struct;const what:string):ansistring;
begin
 getheader:=getheader2(ss.req,what);
end;

procedure send_handle(var ss:send_struct;islim:boolean;lim:u_val);
var
 siz:u_val;
begin
 while (true) do begin
  if ss.oc=client_buffer then begin
   if islim then dec(lim,ss.oc);
   flush_buffer(ss);
   if islim then if lim<=0 then break;{konec cteni}
  end;
  siz:=client_buffer;
  if siz+ss.oc>client_buffer then siz:=client_buffer-ss.oc;
  if islim then if siz>lim then siz:=lim;
  if BOOL(readfile(ss.h,ss.out^[ss.oc+1],siz,siz,nil))<>0 then begin
   if siz=0 then begin
    ss.oc:=ss.oc+siz;
    break;
   end;
  end else begin;
   break;
  end;
  ss.oc:=ss.oc+siz;
 end;
end;

procedure send_pchar(var ss:send_struct;p:pchar);
begin
 if p=nil then exit;
 while (p^<>#0) do begin
  if ss.oc=client_buffer then flush_buffer(ss);
  ss.out^[ss.oc+1]:=ord(p^);
  inc(ss.oc);
  inc(p);
 end;
end;

procedure send_bstring(var ss:send_struct;st:ansistring);
var i:integer;
begin
 for i:=1 to length(st) do begin
  if ss.oc=client_buffer then flush_buffer(ss);
  ss.out^[ss.oc+1]:=ord(st[i]);
  inc(ss.oc);
 end;
end;

procedure send_string(var ss:send_struct;st:string);
var i:integer;
begin
 for i:=1 to length(st) do begin
  if ss.oc=client_buffer then flush_buffer(ss);
  ss.out^[ss.oc+1]:=ord(st[i]);
  inc(ss.oc);
 end;
end;

procedure send_buffer(var ss:send_struct;const data;j:u_val);
var i,siz:u_val;
begin
 i:=0;
 while (i<j) do begin
  if ss.oc=client_buffer then flush_buffer(ss);
  siz:=j-i;
  if siz+ss.oc>client_buffer then siz:=client_buffer-ss.oc;
  move(a0(data)[i],ss.out^[ss.oc+1],siz);
  ss.oc:=ss.oc+siz;
  i:=i+siz;
 end;
end;

const
 hCh:array [0..$F] of Char='0123456789ABCDEF';

function hexb(w:byte):string;
begin
 hexb:=hch[((w and $f0)shr 4)]+hch[((w and $0f))];
end;

type w4rec=packed record
 d,c,b,a:byte;
 end;
function hexl(w:longint):string;
begin
 hexl:=
 hCh[w4rec(w).a shr 4]+hCh[w4rec(w).a and $F]+
 hCh[w4rec(w).b shr 4]+hCh[w4rec(w).b and $F]+
 hCh[w4rec(w).c shr 4]+hCh[w4rec(w).c and $F]+
 hCh[w4rec(w).d shr 4]+hCh[w4rec(w).d and $F];
end;

function urlencode(const s:ansistring):ansistring;
var
 q:integer;
 t:ansistring;
begin
 q:=1;
 t:='';
 while q<=length(s) do begin
  if (s[q]<=#32) or (s[q]>#127) or (s[q]='%') then t:=t+'%'+hexb(ord(s[q]))
  else t:=t+s[q];
  inc(q);
 end;
 urlencode:=t;
end;

function urldecode(const s:ansistring):ansistring;
var
 q:integer;
 b:integer;
 t:ansistring;
begin
 q:=1;
 t:='';
 while q<=length(s) do begin
  if (s[q]='%') then begin
   if s[q+1] in ['0'..'9'] then b:=16*(ord(s[q+1])-ord('0')) else b:=16*(ord(upcase(s[q+1]))-(ord('A')-10));
   if s[q+2] in ['0'..'9'] then b:=b+ord(s[q+2])-ord('0') else b:=b+ord(upcase(s[q+2]))-(ord('A')-10);
   t:=t+chr(b);
   inc(q,2);
  end else t:=t+s[q];
  inc(q);
 end;
 urldecode:=t;
end;

function isaddrp(s:pchar):boolean;
var i:u_val;
begin
 i:=0;
 while s[i]<>#0 do
 begin
  case s[i] of
  '.','0'..'9':;
  else begin isaddrp:=false;exit;end;
  end;
  inc(i);
 end;
 isaddrp:=true;
end;

function resolve(name:pchar):long;
var
 ph:PHOSTENT;
begin
 if name[0]=#0 then begin resolve:=0;exit;end;
 if (isaddrp(name)) then begin resolve:=ntohl(inet_addr(name));exit;end;
 ph:=gethostbyname(name);
 if ph=nil then resolve:=INADDR_NONE
 else begin
  resolve:=ntohl(pu_long(ph^.h_addr_list^)^);
  if (ph^.h_length<>4) or (ph^.h_addrtype<>AF_INET) then resolve:=INADDR_NONE;
 end;
end;

function trycopy(i_s:socket;o_s:socket;b:p0;var xbz:integer):boolean;
var
 ifds:fd_set;
 tm0:timeval;
 xby,i:integer;
begin
 xby:=0;
 ifds.fd_count:=1;
 ifds.fd_array[0]:=i_s;
 tm0.tv_sec:=0;
 tm0.tv_usec:=0;
 if select(0,@ifds,nil,nil,@tm0)=1 then begin
  {skopci, bacha na zbytek z bufferu}
  i:=recv(i_s,@(b^[xby]),pipe_buffer-xby,0);
  if i=0 then dec(xbz);
  if i=SOCKET_ERROR then begin
   inc(sockerrors);
   trycopy:=false;
   exit;
  end;
  inc(xby,i);
  {todo: select on write}
  i:=send(o_s,@(b^[0]),xby,0);
  if i=SOCKET_ERROR then begin
   inc(sockerrors);
   trycopy:=false;
   exit;
  end;
{  if i<>xby then logwrite('TODO: handle buffer mismatch '+strl(i)+'<>'+strl(xby));}
 end;
 trycopy:=true;
end;

procedure startsockpipe(os,ns:socket);
var
 tmp:timeval;
 oby,nby,i:integer;
 tm:u_val;
 nb:p0;
 r_fds:fd_set;
begin
 getmem(nb,pipe_buffer);
 tmp.tv_sec:=pipe_timeout div 1000;
 tmp.tv_usec:=0;
 oby:=0;
 nby:=0;
 repeat
  tm:=gettickcount;
  r_fds.fd_count:=2;
  r_fds.fd_array[0]:=ns;
  r_fds.fd_array[1]:=os;
  i:=select(0,@r_fds,nil,nil,@tmp);
  if i in [1,2] then begin
   if __WSAFDIsSet(ns,@r_fds)<>0 then begin
    if not(trycopy(ns,os,nb,nby)) then break;
    if nby<0 then shutdown(os,sd_send);
   end;
   if __WSAFDIsSet(os,@r_fds)<>0 then begin
    if not(trycopy(os,ns,nb,oby)) then break;
    if oby<0 then shutdown(ns,sd_send);
   end;
   if (nby<0) and (oby<0) then break;
  end else break;
  if (gettickcount>=(pipe_timeout-100+tm)) then break;
 until false;
 freemem(nb,pipe_buffer);
 if os<>invalid_socket then closesocket(os);
 if ns<>invalid_socket then closesocket(ns);
end;

function open_sock(const host:ansistring;xport:word;var err:integer):socket;
var
 inx:sockaddr_in;
 sock:SOCKET;
 ip:longint;
 i:integer;
begin
 err:=0;
 fillchar(inx,sizeof(inx),0);
 sock:=(_socket(AF_INET,SOCK_STREAM,IPPROTO_IP));
 if (sock=INVALID_SOCKET) then begin
  err:=1;
  open_sock:=INVALID_SOCKET;
  exit;
 end;
 ip:=resolve(pchar(host));
 if ip=INADDR_NONE then begin
  err:=-1;
  open_sock:=INVALID_SOCKET;
  exit;
 end;
 inx.sin_family:=AF_INET;
 inx.sin_port:=htons(xport);
 inx.sin_addr.s_addr:=htonl(ip);
 i:=connect(sock,psockaddr(@inx),sizeof(inx));
 if (i=SOCKET_ERROR) then begin
  err:=wsagetlasterror;
  closesocket(sock);
  open_sock:=INVALID_SOCKET;
 end else open_sock:=sock;
end;

function getline(const s:ansistring;var c:integer;var x:ansistring):boolean;
var l:longint;
begin
 x:='';
 l:=length(s);
 getline:=false;
 if c>l then exit;
 while s[c]<>#10 do begin
  if s[c]<>#13 then begin
   x:=x+s[c];
   getline:=true;
  end;
  if c>=l then break;
  inc(c);
 end;
 inc(c);
end;

function reslash(s:ansistring):ansistring;
var i,l:integer;
begin
 l:=length(s);
 if l>0 then for i:=1 to l do begin
  if s[i]='\' then s[i]:='/';
 end;
 reslash:=s;
end;

const
 B64:string='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';

function base64decode(q:string):string;
var
 qq,r,l,i:longint;
begin
 l:=length(q);
 if (l=0) or ((l and 3)<>0) then base64decode:='' else begin
  qq:=0;
  for i:=1 to l div 4 do begin
   r:=plongint(@q[i*4-3])^;
   with w4rec(r) do begin;
    d:=pos(chr(d),b64)-1;
    c:=pos(chr(c),b64)-1;
    b:=pos(chr(b),b64)-1;
    a:=pos(chr(a),b64)-1;
    if a=64 then qq:=1;
    if b=64 then qq:=2;
   end;
   r:=((r and $000000ff) shl 18)
   or ((r and $0000ff00) shl 4)
   or ((r and $00ff0000) shr 10)
   or ((r and $ff000000) shr 24);
   q[i*3-2]:=chr(w4rec(r).b);
   q[i*3-1]:=chr(w4rec(r).c);
   q[i*3  ]:=chr(w4rec(r).d);
  end;
  setlength(q,(l div 4)*3-qq);
  base64decode:=q;
 end;
end;

function checkcrlf(const b:pbuffer;j:integer):integer;
{vraci index od 1 na prvni znak tela}
var i:integer;
begin
 if j<4 then begin
  checkcrlf:=0;
  exit;
 end;
 for i:=1 to j-3 do begin
  if (plong(@(b^[i]))^=$0a0d0a0d) then begin
   checkcrlf:=i+4;
   exit;
  end;
  if (b^[i]=$0a) and (b^[i+1]=$0a) then begin
   checkcrlf:=i+2;
   exit;
  end;
 end;
 for i:=j-2 to j-1 do begin
  if (b^[i]=$0a) and (b^[i+1]=$0a) then begin
   checkcrlf:=i+2;
   exit;
  end;
 end;
 checkcrlf:=0;
end;

function matchq(a:string;b:string):boolean;
var
 i:integer;
begin
 if length(a)<length(b) then matchq:=false
 else begin
  for i:=1 to length(b) do begin
   if b[i]='?' then continue;
   if (locase(a[i])<>locase(b[i])) then begin
    matchq:=false;
    exit;
   end;
  end;
  matchq:=true;
 end;
end;

function getfile(const s:ansistring):ansistring;
var i:integer;
 t:ansistring;
begin
 t:='';
 for i:=length(s) downto 1 do begin
  if s[i]='\' then break else begin
   if not((t='') and (s[i] in [' ',#0])) then t:=locase(s[i])+t;
  end;
 end;
 getfile:=t;
end;

function getdirectory(const s:ansistring):ansistring;
var i:integer;
begin
 getdirectory:='';
 for i:=length(s) downto 0 do begin
  if i=0 then exit;
  if s[i]='\' then begin
   getdirectory:=copy(s,1,i-1);
   exit;
  end;
 end;
end;

{*prevede retezec na cislo, pokud to neni cislo, tak vrati default}
function ival(const s:string;default:integer):integer;
var i,e,l:integer;
begin
 l:=length(s);
 if l=0 then begin
  ival:=default;
  exit;
 end;
 while (l>0) do begin
  if s[l] in [' ',#9,'.'] then dec(l) else break;
 end;
 if l<length(s) then val(copy(s,1,l),i,e) else val(s,i,e);
 if e<>0 then ival:=default else ival:=i;
end;

{* prevede retezec na boolean (true/false)}
function bval(const s:string):boolean;
begin
 bval:=ival(s,0)>0;
end;

function getextension(const s:ansistring):ansistring;
var i:integer;
 t:ansistring;
begin
 t:='';
 for i:=length(s) downto 1 do begin
  if s[i]='.' then break else begin
    if not((t='') and (s[i] in [' ',#0])) then t:=locase(s[i])+t;
  end;
 end;
 if length(s)=length(t) then getextension:='' else getextension:=t;
end;
