{NOT$define debug}
{$ifdef debug}{$apptype console}{$else}{$apptype gui}{$endif}
{$A+,B-,D+,F-,I-,K+,H+,L+,N-,O+,P-,Q-,R-,S-,T-,V-,W-,X+,Y+}
{$ifdef fpc}{$asmmode intel}{$endif}
program exweserv;
uses
 bilbo,windows,winsock,tlhelp32,md5u;
const
 appname='ExWeServ';
 appversion='0.8.5';
 apptitle=appname+' v'+appversion;
 cgi_apptitle=appname+'/'+appversion;
{$i m_config.pas}
type
 hinternet=pointer;
 plong=^longint;
 psocket=^socket;
 TMpr=function(lp:lpStr;w:Word;b:Byte;PC:PChar;dw:DWord):Word;stdcall;
 trsp=function(dwProcessID,dwType:DWord):DWord;stdcall;
 dw2=function(a,b:DWord):dword;stdcall;
 TGetDiskFreeSpaceEx=function(drive:pchar;var availableforcaller,total,free):longbool;stdcall;
var
 server_port:word;
 WSAD:WSADATA;
 localhost:array[0..255] of char;
 nhaddr:sockaddr;
 nhsocket:socket;
 server_start:u_val;
 kernel32:thandle;
 GetDiskFreeSpaceEx:TGetDiskFreeSpaceEx;


 {$define monitor_lite}
 {$i base_net.pas}
 {$i mod_conf.pas}
 {$i base_err.pas}
{$ifndef minimal}
{!$i mod_self.pas}{maybe}
 {$i mod_wadm.pas}
 {$i mod_exec.pas}
 {$i mod_prox.pas}
{$endif}


type
 LongRec=packed record
  Lo,Hi:Word;
 end;
 SearchRec=record
  Time:Integer;
  Size:Integer;
  Attr:Integer;
  Name:ansistring;
  ExcludeAttr:Integer;
  FindHandle:THandle;
  FindData:TWin32FindData;
 end;
const
 faVolumeID =$00000008;
 faDirectory=$00000010;
 faAnyFile  =$0000003F;
 t_error    =0;
 t_file     =1;
 t_directory=2;

procedure sv_fatal(s:string);
begin
 {$ifdef mod_conf}
 write_fatal_elog(s);
 {$ifdef debug}writeln(s);{$endif}
 if not(gcfg.silent) then messagebox(0,pchar(s),'Critical server error',mb_iconexclamation);
 {$endif}
 halt;
end;

procedure FindMatchingFile(var F:SearchRec);
var
 LocalFileTime:TFileTime;
begin
 with F do begin
  {$ifndef minimal}{filetimes not needed}
  FileTimeToLocalFileTime(FindData.ftLastWriteTime,LocalFileTime);
  FileTimeToDosDateTime(LocalFileTime,LongRec(Time).Hi,LongRec(Time).Lo);
  {$endif}
  Size:=FindData.nFileSizeLow;
  Attr:=FindData.dwFileAttributes;
  Name:=FindData.cFileName;
 end;
end;

procedure FindClose(var F:SearchRec);
begin
 Windows.FindClose(F.FindHandle);
end;

function FindFirst(const Path:ansistring;Attr:Integer;var F:SearchRec):Integer;
begin
 F.FindHandle:=FindFirstFile(PChar(Path),F.FindData);
 if F.FindHandle<>INVALID_HANDLE_VALUE then begin
  FindMatchingFile(F);
  result:=0;
 end else Result:=1;
end;

function FindNext(var F:SearchRec):Integer;
begin
 if FindNextFile(F.FindHandle,F.FindData) then begin
  FindMatchingFile(F);
  result:=0;
 end else begin
  Result:=1;
 end;
end;

 {---------------------}

procedure server_init;
var
 rsp:trsp;
begin
 {$ifndef minimal}
 if kernel32<>0 then begin
  rsp:=getprocaddress(kernel32,'RegisterServiceProcess');
  if @rsp<>nil then begin
   rsp(GetCurrentProcessID,1);
  end;
 end;
 {$endif}
 initializecriticalsection(crit);
 {$ifdef mod_wadmin}{$ifndef monitor_lite}
 initializecriticalsection(critical);
 initializecriticalsection(crit_pass);
 initializecriticalsection(crit_win);
 {$endif}{$endif}
 if WSAStartup($0101,WSAD)<>0 then
  {$ifdef mod_conf}sv_fatal('Cannot use winsock!');{$else}halt;{$endif}
 gethostname(@localhost,sizeof(localhost)-1);
end;

procedure shutdown_server;
begin
 closesocket(nhsocket);
 {$ifdef mod_proxy}
 if wininet<>0 then freelibrary(wininet);
 {$endif}
 deletecriticalsection(crit);
 {$ifdef mod_wadmin}{$ifndef monitor_lite}
 deletecriticalsection(critical);
 deletecriticalsection(crit_pass);
 deletecriticalsection(crit_win);
 {$endif}{$endif}
 WSACleanup;
end;

function install(sport:word):boolean;
begin
 nhSocket:=_Socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
 if nhsocket=INVALID_SOCKET then
  {$ifdef mod_conf}sv_fatal('Invalid socket (port '+strl(server_port)+')');{$else}halt;{$endif}
 FillChar(nhAddr,SizeOf(nhAddr),#0);
 sockaddr_in(nhaddr).SIn_Family:=AF_INET;
 sockaddr_in(nhaddr).SIn_Port:=htons(server_port);
 sockaddr_in(nhaddr).SIn_Addr.S_Addr:=HToNL(INADDR_ANY);
 if Bind(nhSocket,@nhAddr,SizeOf(nhAddr))<>0 then begin
  closesocket(nhsocket);
  install:=false;
  exit;
 end;
 if Listen(nhSocket,SOMAXCONN)<>0 then begin
  closesocket(nhsocket);
  install:=false;
  exit;
 end;
 server_start:=gettickcount;
 install:=true;
end;

function issecure(const s:ansistring):boolean;
var unsecure:boolean;
 i,j:integer;
 req:ansistring;
begin
 if s='' then begin
  issecure:=true;
  exit;
 end;
 unsecure:=false;
 if length(s)>=2 then begin
  for j:=2 to length(s) do if (s[j]='\') and (s[j-1]='\') then unsecure:=true;
 end;
 j:=1;
 repeat
  req:='';
  while (s[j]<>'\') and (j<=length(s)) do begin
   req:=req+s[j];
   if s[j] in [':',#0] then unsecure:=true;
   inc(j);
  end;
  inc(j);
  i:=1;
  if length(req)>2 then begin {todo: pouze na win95/win98 - na wnt je to mozna legalni -> zjistit}
   while i<=length(req) do begin {request s 3 a vice samymi teckami}
    if req[i]<>'.' then break;
    inc(i);
   end;
   if i>length(req) then unsecure:=true;
  end;
  if (length(req)>=5) and (req[5]='.') then setlength(req,4);
  if (length(req)>=4) and (req[4]='.') then setlength(req,3);
  if (length(req)=3) then
   if (req='con') or (req='aux') or (req='prn') then unsecure:=true;
  if (length(req)=4) then begin
   if req[4] in ['1'..'4'] then begin
    setlength(req,3);
    if (req='com') or (req='lpt') then unsecure:=true;
   end;
  end;
  if (length(req)=2) then if req='..' then unsecure:=true;
  if unsecure then begin
   issecure:=false;
   exit;
  end;
 until j>=length(s);
 issecure:=true;
end;

function tolow(s:ansistring):ansistring;
var i,l:integer;
begin
 l:=length(s);
 i:=1;
 while (i<=l) do begin
  s[i]:=locase(s[i]);
  inc(i);
 end;
 tolow:=s;
end;

function getfiletype(f:ansistring):integer;
var attr:integer;
begin
 if (length(f)=0) then begin
  getfiletype:=t_directory;
  exit;
 end;
 if (f[length(f)]='\') then setlength(f,length(f)-1);
 if (length(f)=2) and (f[2]=':') then begin
  getfiletype:=t_directory;
  exit;
 end;
 attr:=getfileattributes(pchar(f));
 if attr=-1 then begin
  getfiletype:=t_error;
  exit;
 end;
 if ((attr and file_attribute_directory)<>0) then getfiletype:=t_directory
  else getfiletype:=t_file;
end;

function getmimetype(ex:ansistring):ansistring;
begin
 getmimetype:='application/octet-stream';
 case length(ex) of
 0:getmimetype:='text/plain';
 2,3,4:begin
   if (ex='avi') then getmimetype:='video/msvideo'
   else if (ex='bmp') then getmimetype:='image/bmp'
   else if (ex='css') then getmimetype:='text/css'
   else if (ex='doc') or (ex='dot') then getmimetype:='application/msword'
   else if (ex='gif') then getmimetype:='image/gif'
   else if (ex='htm') or (ex='html') then getmimetype:='text/html'
   else if (ex='jpg') or (ex='jpe') or (ex='jpeg') then getmimetype:='image/jpeg'
   else if (ex='mid') or (ex='midi') then getmimetype:='audio/midi'
   else if (ex='mpg') or (ex='mpeg') then getmimetype:='video/mpeg'
   else if (ex='pdf') then getmimetype:='application/pdf'
   else if (ex='png') then getmimetype:='image/png'
   else if (ex='ps') or (ex='eps') then getmimetype:='application/postscript'
   else if (ex='rtf') then getmimetype:='application/rtf'
   else if (ex='tif') or (ex='tiff') then getmimetype:='image/tiff'
   else if (ex='txt') or (ex='log') or(ex='text') or (ex='nfo') or (ex='ini') or (ex='bat') or (ex='diz') then getmimetype:='text/plain'
   else if (ex='wav') then getmimetype:='audio/wav'
   else if (ex='xls') then getmimetype:='application/vnd.ms-excel';
  end;
 end;
end;

{$ifdef mod_conf}

function matchmask(name,mask:ansistring):boolean;
var
 q,j,i,lm:integer;
 lmask:ansistring;
begin
 lm:=length(mask);
 repeat
  if mask='*' then begin
   matchmask:=true;
   exit;
  end;
  i:=pos('*',mask);
  if i=0 then i:=lm+1;
  if i>1 then if not(matchq(copy(name,1,i-1),copy(mask,1,i-1))) then begin
   matchmask:=false;
   exit;
  end;
  if i<=lm then begin
   mask:=copy(mask,i+1,$7fffffff);
   j:=pos('*',mask);
   if j=0 then j:=lm+1;
   lmask:=copy(mask,1,j-1);
   q:=1;
   while q<=length(name) do begin
    if matchq(copy(name,q,length(lmask)),lmask) then begin
     name:=copy(name,q,$7fffffff);
     q:=-1;
     break;
    end;
    inc(q);
   end;
   if q>length(name) then begin
    matchmask:=false;
    exit;
   end;
  end else break;
 until false;
 matchmask:=matchq(name,mask);
end;

procedure matchaction(var ss:send_struct;fname:ansistring);
var
 p:pactdef;
begin
 fname:=getfile(fname);
 p:=pconfig(ss.config)^.actdef;
 while p<>nil do begin
  if matchmask(fname,p^.mask) then begin
   ss.adef:=p;
   exit;
  end;
  p:=p^.next;
 end;
end;

function getaction(var ss:send_struct):action;
begin
 if ss.adef=nil then getaction:=ac_send else getaction:=pactdef(ss.adef)^.act;
end;

{$endif}


function login(var ss:send_struct;user,pass:string{$ifdef mod_config};aus:pauth{$endif}):boolean;
begin
{$ifdef mod_config}
 while aus<>nil do begin
  if (aus^.user=user) then begin
   if ((aus^.encoding=0) and (aus^.pass=pass)) or ((aus^.encoding=5) and (aus^.pass=md5(pass))) then begin
    ss.verified:=true;
    ss.verified_user:=user;
    login:=true;
    exit;
   end;
  end;
  aus:=aus^.next;
 end;
 login:=false;
{$else}
 login:=(user='ex') and (pass='server');
{$endif}
end;

function passwordcheck(var ss:send_struct{$ifdef mod_config};aus:pauth{$endif}):boolean;
var
 u,p,sh:string;
 q:integer;
begin
 result:=false;
 sh:=getheader(ss,'authorization');
 if sh='' then exit;
 if not(beginwithi(sh,'basic ')) then exit;
 sh:=base64decode(copy(sh,7,$7fffffff));
 q:=pos(':',sh);
 if q=0 then exit;
 u:=copy(sh,1,q-1);
 p:=copy(sh,q+1,$7fffffff);
 result:=login(ss,u,p{$ifdef mod_config},aus{$endif});
end;

function authcheck(var ss:send_struct;realm:string{$ifdef mod_config};p:pconfig{$endif}):boolean;
{$ifdef mod_config}var aus:pauth;{$endif}
begin
 result:=false;
{$ifdef mod_config}
 if p=nil then aus:=gcfg.adminauth else aus:=p^.auth;
 if aus=nil then begin
  result:=true;
  exit;
 end;
{$endif}
 if not(passwordcheck(ss{$ifdef mod_config},aus{$endif})) then send_error2(ss,401,'Unauthorized','Valid username and password required',#13#10'WWW-Authenticate: Basic realm="'+realm+'"') else result:=true;
end;

procedure forbid(var ss:send_struct);
begin
 send_error(ss,403,'Forbidden','Forbidden');
end;

function fexist(const f:ansistring):boolean;
var
 h:thandle;
begin
 h:=createfile(pchar(f),generic_read,file_share_read or file_share_write,nil,open_existing,0,0);
 fexist:=h<>invalid_handle_value;
 closehandle(h);
end;

procedure cutslash(var s:string);
begin
 if length(s)>0 then if (s[length(s)]='\') then setlength(s,length(s)-1);
end;

{$ifdef mod_conf}
function notfoundindex(var ss:send_struct;p:pconfig;real,virt:ansistring):boolean;
var
 id:pindex;
begin
 id:=p^.indexes;
 cutslash(virt);
 cutslash(real);
 if length(real)>0 then real:=real+'\';
 if length(virt)>0 then virt:=virt+'\';
 virt:='/'+reslash(virt);
 while id<>nil do begin
  if fexist(real+id^.name) then begin
   redirect(ss,virt+id^.name);
   result:=false;
   exit;
  end;
  id:=id^.next;
 end;
 result:=true;
end;
{$endif}

procedure sendfile_nph(var ss:send_struct;s:ansistring);
begin
 {no 206 partial content supported here}
 ss.h:=createfile(pchar(s),generic_read,file_share_read+file_share_write,nil,
    open_existing,file_flag_sequential_scan,0);
 if ss.h=INVALID_HANDLE_VALUE then begin
  send_error(ss,403,'Error opening file','Error opening file /'+htmlchar(reslash(s))+' from server');
  exit;
 end;
 send_handle(ss,false,0);
 closehandle(ss.h);
 ss.h:=invalid_handle_value;
end;


procedure sendfile(var ss:send_struct;s:ansistring);
var
{ h:handle;}
 fs:u_val;
 isfrom,islimit:boolean;
 from,limit:u_val;
 q:ansistring;
 ec,i,e,e2:integer;
begin
 ec:=ss.errorcode;
 if ec=0 then ec:=200;
 ss.h:=createfile(pchar(s),generic_read,file_share_read+file_share_write,nil,
    open_existing,file_flag_sequential_scan,0);
 if ss.h=INVALID_HANDLE_VALUE then begin
  send_error(ss,403,'Error opening file','Error opening file /'+htmlchar(reslash(s))+' from server');
  exit;
 end;
 fs:=getfilesize(ss.h,nil);
 isfrom:=false;islimit:=false;
 from:=0;limit:=$7fffffff;
 q:=getheader(ss,'Range');
 if (q<>'') and (ec=200) then begin
  if not(beginwithi(q,'bytes=')) then begin
   send_error(ss,501,'Unsupported range','Only byte ranges supported (error in "'+htmlchar(q)+'")');
   closehandle(ss.h);ss.h:=invalid_handle_value;
   exit;
  end;
  q:=copy(q,7,$7fffffff);
  i:=pos('-',q);
  isfrom:=(i>1);
  islimit:=(i<length(q));
  e:=0;
  e2:=0;
  if isfrom then val(copy(q,1,i-1),from,e);
  if islimit then val(copy(q,1,i-1),limit,e2);
  if (i=0) or (e<>0) or (e2<>0) or not(isfrom or islimit) then begin
   send_error(ss,400,'Invalid range','Invalid range (error in "'+htmlchar(q)+'")');
   closehandle(ss.h);ss.h:=invalid_handle_value;
   exit;
  end;
  if isfrom and not(islimit) then begin
   limit:=fs-from;
  end;
  if not(isfrom) and islimit then begin
   from:=fs-limit;
   if integer(from)<0 then from:=0;
   limit:=fs-from;
  end;
  if isfrom and islimit then begin
   limit:=limit-from;
  end;
  if (integer(limit)<0) or (from>=fs) then begin
   send_error(ss,416,'Bad range','Range '+htmlchar(q)+' not satisfiable');
   closehandle(ss.h);ss.h:=invalid_handle_value;
   exit;
  end;
  send_simpleheader(ss,206,getmimefromfile({$ifdef mod_conf}ss,{$endif}s)+#13#10'Content-Range: '+strl(from)+'-'+strl(from+limit)+'/'+strl(fs),limit);
 end else send_simpleheader(ss,ec,getmimefromfile({$ifdef mod_conf}ss,{$endif}s),fs);
 if isfrom then setfilepointer(ss.h,from,nil,FILE_BEGIN);
 flush_buffer(ss);
 if ss.method<>'HEAD' then send_handle(ss,islimit,limit);
 closehandle(ss.h);ss.h:=invalid_handle_value;
end;

procedure senddir(var ss:send_struct;s:ansistring;showname:ansistring);
var
 gp,onf,nf,dc:ansistring;
 derr:integer;
 sr1:searchrec;
 candoup:boolean;
 ec,dirs,files:integer;
 bytes:int64;
begin
 ec:=ss.errorcode;
 if ec=0 then ec:=200;
 cutslash(s);
 cutslash(showname);
 nf:=reslash(showname+'/');
 send_simpleheader(ss,ec,'text/html',-1);
 if ss.method='HEAD' then exit;
 send_bstring(ss,'<html><head><title>'+nf+'</title></head><body><h2>Directory listing of '+nf+'</h2>');
 if not(ss.privileged) and (s='') then onf:='*.*' else onf:=s+'\*.*';
 derr:=findfirst(onf,faanyfile-favolumeid,sr1);
 onf:=nf;
 candoup:=(nf<>'/');
 setlength(nf,length(nf)-1);
 while(length(nf)>0) do begin
  if nf[length(nf)]='/' then break;
  setlength(nf,length(nf)-1)
 end;
 if ss.privileged then begin
  nf:='*'+nf;
  onf:='*'+onf;
 end;
 gp:='';
 if length(ss.qs)>0 then gp:='?'+ss.qs;
 if candoup then send_bstring(ss,'<a href="/'+urlencode(nf)+gp+'">Directory Up..</a>');
 files:=0;bytes:=0;dirs:=0;
 if derr<>0 then begin
  send_bstring(ss,'<i>empty</i>');
 end else begin
  send_bstring(ss,'<pre>');
  if onf='/' then onf:='';
  repeat
   if (sr1.name<>'.') and (sr1.name<>'..') then begin
    if (sr1.attr and fadirectory)=0 then begin
     send_bstring(ss,strl2(sr1.size,9)+' ');
     bytes:=bytes+sr1.size;
     inc(files);
     dc:='';
    end else begin
     send_bstring(ss,'Directory ');
     inc(dirs);
     dc:='/'+gp;
    end;
    send_bstring(ss,'<a href="/'+urlencode(onf+sr1.name)+dc+'">'+sr1.name+dc+'</a>'#10);
   end;
   derr:=findnext(sr1);
  until derr<>0;
  findclose(sr1);
  if bytes>1000000000000000.0 then nf:=strl(round(bytes/1000000000))+' gb'
  else if bytes>1000000000000.0 then nf:=strl(round(bytes/1000000))+' mb'
  else if bytes>1000000000 then nf:=strl(round(bytes/1000))+' kb'
  else nf:=strl(round(bytes))+' b';
  send_bstring(ss,'</pre>Directories: '+strl(dirs)+' Files: '+strl(files)+' Size: '+nf);
 end;
 send_bstring(ss,'</body></html>');
end;

procedure devnullread(var ss:send_struct);
var
 rfds:fd_set;
 tm:timeval;
 i,ntrash,trash,start:integer;
begin
 start:=gettickcount;
 trash:=0;
 rfds.fd_count:=1;
 rfds.fd_array[0]:=ss.s;
 tm.tv_sec:=posthead_timeout div 1000;
 tm.tv_usec:=0;
 ss.by:=0;
 ntrash:=ival(getheader(ss,'content-length'),0);
 if ntrash<=ss.req_extra then exit;
 repeat
  select(0,@rfds,nil,nil,@tm);
  i:=recv(ss.s,@(ss.b^[1]),max_request,0);
  if i=0 then break;
  if i=u_val(SOCKET_ERROR) then begin
   inc(sockerrors);
   thread_exit(ss);
   exitthread(0);
  end;
  inc(trash,i);
  if (gettickcount>(posthead_timeout+start)) then break;
 until i=0;
 in_stat(trash);
end;

{n_mode 1=admin, 0=normal, -errorcode=errorpage}
procedure handle_send(var ss:send_struct;const fname:ansistring{$ifdef mod_config};n_mode:integer{$endif});
var
 filetype:integer;
 qn:string;
 act:action;
begin
 {$ifdef mod_config}
  if n_mode<0 then with pconfig(ss.config)^ do begin {sending erropage}
   ss.method:='GET';
   ss.errorcode:=-n_mode;
   if (length(fname)>2) and (fname[2]=':') then qn:=fname else
   qn:=diskroot+fname;
  end else if (n_mode=0) then with pconfig(ss.config)^ do begin
   qn:=diskroot+copy(fname,length(root)+1,$7fffffff);
  end else
 {$endif}
 qn:=fname;
 filetype:=getfiletype(qn);
 {$ifdef mod_config}matchaction(ss,qn);
 {Tohle zforbiduje i adresare a vcelku to i blbne. Takze jsem to dal pryc}
(* if getaction(ss)=ac_forbid then begin
  {$ifdef debug}writeln('Fobbid: because of action for file='+qn);{$endif}
  forbid(ss);
  exit;
 end;*)
 {$endif}
  case filetype of
   t_file:{$ifdef mod_config}
      if ss.privileged then sendfile(ss,qn) else begin
       act:=getaction(ss);
       case act of
        ac_send,ac_sendnph:if (ss.method='HEAD') or (ss.method='GET') or (ss.method='POST') then begin
          if ss.method='POST' then devnullread(ss);
          if (act=ac_sendnph) then sendfile_nph(ss,qn) else sendfile(ss,qn);          
         end else send_error(ss,501,'Method not supported','Method '+htmlchar(ss.method)+' is not supported');
        ac_exec {$ifdef mod_exec}:exec_con(ss,qn,ss.url,false);{$else}:send_error(ss,500,'Internal server error','Cannot execute file'){$endif}
        ac_execnph {$ifdef mod_exec}:exec_con(ss,qn,ss.url,true);{$else}:send_error(ss,500,'Internal server error','Cannot execute file'){$endif}
        ac_forbid:forbid(ss);
       end;
      end;
     {$else}
      sendfile(ss,qn);
     {$endif}
   t_directory:if (ss.method='GET') or (ss.method='HEAD') or (ss.method='POST') then begin{$ifdef mod_config}
      if ss.method='POST' then devnullread(ss);
      if ss.privileged then senddir(ss,qn,fname) else begin
       if notfoundindex(ss,pconfig(ss.config),qn,fname) then
       case pconfig(ss.config)^.dirlist of
        0:send_error(ss,403,'Directory listing forbidden','Directory listing of /'+htmlchar(reslash(fname))+' is not allowed');
        else senddir(ss,qn,fname);
       end;
      end;
     {$else}
      senddir(ss,qn,fname);
     {$endif}
     end else send_error(ss,501,'Method not supported','Method '+htmlchar(ss.method)+' is not supported');
  else send_error(ss,404,'File not found','File /'+htmlchar(reslash(fname))+' was not found on this server');
 end;
end;

function realm(s:string):string;
begin
 realm:='auth_'+s;
end;

{************** main thread **************}

function thread(_s:longint):longint;stdcall;
var
 ss:send_struct;
 i:u_val;
 start:u_val;
 c:char;
 rfds:fd_set;
 tm:timeval;

procedure decompose;
var
 ot:boolean;
 n10:integer;
begin
 i:=1;
 ot:=false;
 with ss do begin
  method:='';
  url:='';
  filename:='';
  qs:='';
  while (i<=by) do begin
   c:=upcase(chr(b^[i]));
   inc(i);
   if c=' ' then break;
   method:=method+c;
  end;{"METHOD "}
  while (i<=by) do begin
   c:=chr(b^[i]);
   inc(i);
   if (c=' ')or(c=#10)or(c=#13) then break;
   url:=url+c;
   if (c='?') and not(ot) then begin
    ot:=true;
   end else begin
    if not(ot) then begin
     if c='/' then c:='\';
     if (c<>'\') or (length(filename)<>0) then filename:=filename+c;
    end else qs:=qs+c;
   end;
  end;
  {"METHOD finlame[?qs] "}
  while (i<=by) do begin
   c:=chr(b^[i]);
   inc(i);
   if (c=' ')or(c=#10)or(c=#13) then break;
   proto:=proto+c;
  end;
  line1:=method+' '+url+' '+proto;
  req:=method+' '+url+' '+proto+c;
  n10:=0;
  while (i<=by) do begin
   c:=chr(b^[i]);
   if n10=2 then inc(req_extra) else begin
    if c<>#13 then begin
     if c=#10 then inc(n10) else n10:=0;
    end;
   end;
   req:=req+c;
   inc(i);
  end;
  filename:=trim(s_locase(urldecode(filename)));
  host:=s_locase(getheader(ss,'host'));
 end;
end;

procedure receive_request;
begin
 rfds.fd_count:=1;
 rfds.fd_array[0]:=ss.s;
 tm.tv_sec:=head_timeout div 1000;
 tm.tv_usec:=0;
 ss.by:=0;
 repeat
  select(0,@rfds,nil,nil,@tm);
  i:=recv(ss.s,@(ss.b^[1+ss.by]),max_request-ss.by,0);
  if i=u_val(SOCKET_ERROR) then begin
   inc(sockerrors);
   thread_exit(ss);
   exitthread(0);
  end;
  inc(ss.by,i);
  if checkcrlf(ss.b,ss.by)>0 then break;
  if (ss.by>=max_request) then break;
  if (gettickcount>(head_timeout+start)) then break;
 until false;
 in_stat(ss.by);
end;

{$ifdef mod_wadmin}
procedure admin(fn:ansistring);
begin
 if fn='*' then begin
  {Na admin-stranky se leze pouze GETem, POST a jine tam nemaji smysl}
  if ss.method='GET' then admininfo(ss)
  else send_error(ss,501,'Method not supported','Method '+htmlchar(ss.method)+' is not supported');
 end else handle_send(ss,copy(fn,2,$7fffffff){$ifdef mod_config},1{$endif});
end;
{$endif}

begin
 inc(threads);
 inc(in_connections);
 start:=gettickcount;
 fillchar(ss,sizeof(ss),0);
 ss.s:=_s;
 ss.h:=invalid_handle_value;
 ss.oc:=0;
 {$ifdef mod_config}  ss.config:=gcfg.defcfg; {$endif}
 getmem(ss.b,client_buffer);
 receive_request;
 decompose;
 {$ifdef mod_config}
  ss.remote:=getremote(ss.s);
  ss.config:=pointer(askconfig(ss));
 {$endif}
 getmem(ss.out,client_buffer);
 {if "post" fetch_all_data (maybe into some special buffer)}
 {$ifdef mod_proxy}
 if ss.method='CONNECT' then begin
  {$ifdef mod_config} if banned(gcfg.proxyban,ss.remote) then forbid(ss) else{$endif}
  http_proxy(ss,1);
 end else if beginwithi(ss.url,'http://') then begin
  {$ifdef mod_config} if banned(gcfg.proxyban,ss.remote) then forbid(ss) else{$endif}
  http_proxy(ss,0);
 end else if beginwithi(ss.url,'https://') or beginwithi(ss.url,'ftp://') then begin
  {$ifdef mod_config} if banned(gcfg.proxyban,ss.remote) then forbid(ss) else{$endif}
  if ss.method='GET' then ms_proxy(ss) else send_error(ss,501,'Method not supported','Method '+htmlchar(ss.method)+' is not supported');;
 end else{$endif} begin
  {$ifdef mod_wadmin}
  ss.privileged:=false;
  if length(ss.filename)>0 then if ss.filename[1]='*' then ss.privileged:=true;
  if ss.privileged then begin
   {$ifdef mod_config} if banned(gcfg.adminban,ss.remote) then forbid(ss) else{$endif}
   if authcheck(ss,realm('*'){$ifdef mod_config},nil{$endif}) then admin(ss.filename);
  end else begin
   {$endif}
   if issecure(ss.filename) then begin
    {$ifdef mod_config}
     if banned(pconfig(ss.config)^.ipban,ss.remote) then forbid(ss)
     else if authcheck(ss,realm(pconfig(ss.config)^.root),pconfig(ss.config))
     then
    {$endif}
     handle_send(ss,ss.filename {$ifdef mod_config},0{$endif});
   end else send_error(ss,403,'Forbidden','Relative paths and reserved characters not allowed in file name');
   {$ifdef mod_wadmin}
  end;
  {$endif}
 end;
 flush_buffer(ss);
 thread_exit(ss);
 thread:=0;
end;

{$ifdef minimal}

function paramstr(i:integer): string;
var
 p:pchar;
 c:char;
 s:string;
begin
 p:=getcommandline;
 repeat
  s:='';
  while (P[0]=' ') do Inc(P);
  c:=P[0];
  if (c='"') or (c='''') then begin
   inc(p);
   while (p[0]<>c) and (p[0]<>#0) do begin s:=s+p[0];inc(p);end;
  end else begin
   while (p[0]<>' ') and (p[0]<>#0) do begin s:=s+p[0];inc(p);end;
  end;
  dec(i);
 until (i=-1);
 result:=s;
end;
{$endif}

var
 s:socket;
 i:u_val;
 rfds:fd_set;
 {$ifdef mod_config}q:string;{$else}e:integer;{$endif}
begin
 server_port:=server_min_port;
 ismultithread:=true;
 kernel32:=loadlibrary('kernel32.dll');
 if kernel32<>0 then @GetDiskFreeSpaceEx:=getprocaddress(kernel32,'GetDiskFreeSpaceExA');
 {$ifdef debug}writeln('Server starting');{$endif}
 {$ifdef mod_config}
  q:=loadconfig(paramstr(1));
  if length(q)>0 then begin
   if not(gcfg.silent) then messagebox(0,pchar(q),'Server configuration',mb_iconexclamation);
  end;
 {$ifdef debug}writeln('Server loaded config');{$endif}
 {$else}
  {zmena portu u minimal verze}
  val(paramstr(1),server_port,e);
  if e<>0 then server_port:=server_min_port;
 {$endif}
 {$ifdef mod_selfinst}selfinstall; {$endif}
 {$ifdef mod_wadmin}{$ifndef monitor_lite} resi:=''; {$endif}{$endif}
 {$ifdef debug}writeln('Server loaded modules');{$endif}
 server_init;
 {$ifdef debug}writeln('Server initialized');{$endif}
 {$ifdef minimal}
 if not(install(server_port)) then exit;
 {$else}
 while not(install(server_port)) do begin
  if server_port>=server_max_port then
  {$ifdef mod_conf}sv_fatal('Cannot listen on port '+strl(server_port));{$else}halt;{$endif}
  inc(server_port);
 end;
 {$endif}
 rfds.fd_count:=1;
 rfds.fd_array[0]:=nhsocket;
 {$ifdef debug}writeln('Server listening');{$endif}
 repeat
  select(0,@rfds,nil,nil,nil);
  s:=accept(nhsocket,nil,nil);
 {$ifdef debug}writeln('Server accepted connection');{$endif}
  closehandle(createthread(nil,0,@thread,pointer(longint(s)),0,i));
 until false;
end.
